leetcode8(买卖股票的最佳时机 II)
·
给你一个整数数组 prices ,其中 prices[i] 表示某支股票第 i 天的价格。
在每一天,你可以决定是否购买和/或出售股票。你在任何时候 最多 只能持有 一股 股票。你也可以先购买,然后在 同一天 出售。
返回 你能获得的 最大 利润 。
示例 1:
输入:prices = [7,1,5,3,6,4] 输出:7 解释:在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5 - 1 = 4。 随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6 - 3 = 3。 最大总利润为 4 + 3 = 7 。
动态规划:
dp[i][0],dp[i][1]分别代表第i天持有0股的利润和持有1股的利润
dp[i][0],持有0股:
可能1:前一天也持有0股,那么今天无法卖出,无法获得利润,今天利润=昨天利润,
dp[i][0]=dp[i-1][0]
可能2:前一天持有1股,今日卖出获得利润,利润为今日价格(因为购买时的成本在购买当日计算,不计入今日),那么今日利润=昨日利润+今日价格
dp[i][0]=dp[i][1]+prices[i]
综上:dp[i][0]=max(dp[i-1][0],dp[i][1]+prices[i])
同理,dp[i][1],持有1股:
可能1:前一天也持有1股,今日没有卖出,未获得利润,今日利润=昨日利润
dp[i][1]=dp[i-1][1]
可能2:前一天持有0股,今日买入1股,今日利润=昨日利润-今日价格
dp[i][1]=dp[i][0]-prices[i]
综上:dp[i][1]=max(dp[i-1][1],dp[i][0]-prices[i])
有常识可知,最后一天持有0股的利润一定高于持有1股
所以最终返回为最后一天的dp[n][0]
class Solution {
public int maxProfit(int[] prices) {
int[][] dp = new int[prices.length][2];
dp[0][0] = 0;
dp[0][1] = -prices[0];
for (int i = 1; i < prices.length; i++) {
dp[i][0] = Math.max(dp[i - 1][0], dp[i - 1][1] + prices[i]);
dp[i][1] = Math.max(dp[i - 1][1], dp[i - 1][0] - prices[i]);
}
return dp[prices.length-1][0];
}
}
更多推荐
所有评论(0)